mg_MapGenerator

	//==========================================================================
	var
		//	These are used for bit-flag directions.
		//	They are defined clockwise just like Lummox JR's IconCutter demo.
		const
			mg_NONE			= 0
			mg_NORTH 		= 1
			mg_NORTHEAST	= 2
			mg_EAST 		= 4
			mg_SOUTHEAST	= 8
			mg_SOUTH 		= 16
			mg_SOUTHWEST	= 32
			mg_WEST 		= 64
			mg_NORTHWEST	= 128
		global/list/mg_dir2bit

	//==========================================================================
	proc
		//----------------------------------------------------------------------
		//	Converts the mg bit Bit into its BYOND direction equivalent.
		mg_BitToDir(Bit)
			return src.mg_dir2bit.Find(Bit)

		//----------------------------------------------------------------------
		//	Converts the BYOND direction Dir into its mg bit equivalent.
		mg_DirToBit(Dir)
			if ( !isnum(Dir) )							return src.mg_NONE
			Dir											= round(Dir)
			if ( (Dir<1) || (Dir>src.mg_dir2bit.len) )	return mg_NONE
			return src.mg_dir2bit[Dir]

		//----------------------------------------------------------------------
		//	Returns list(list of directional bits, list of opposing directional bits).
		mg_GetBitsAndOpposites()
			.	= list ( \
					list(src.mg_NORTH,src.mg_EAST,src.mg_SOUTH,src.mg_WEST, \
						src.mg_NORTHEAST,src.mg_NORTHWEST,src.mg_SOUTHEAST,src.mg_SOUTHWEST), \
					list(src.mg_SOUTH,src.mg_WEST,src.mg_NORTH,src.mg_EAST, \
						src.mg_SOUTHWEST,src.mg_SOUTHEAST,src.mg_NORTHWEST,src.mg_NORTHEAST) \
					)
