
client
	verb
		generate(Seed as num)
			set desc = "(Seed as num)"

			//	We'll create a map generator to cover the entire map.
			//	In a real project, it need not be this large.
			var/mg_MapGenerator/MG	= new(null,world.maxx,world.maxy)

			//	We'll use the maze generation algorithm provided.  We'll use
			//	the seed provided and let the generator choose the starting
			//	coordinates.  The final NESW argument being set to TRUE removes
			//	diagonal connections.  (This merely fits with the demo's turf icon.)
			var/list/results	= MG.mg_PrimMazeRectangle(Seed,null,null,TRUE)

			//	mg_PrimMazeRectangle will choose a random seed if the argument
			//	was invalid.  Likewise for the starting coordinates.  The actual
			//	seed and starting index are returned.
			src					<< output(results[1],"seed")
			var/coordinates		= MG.mg_IndexToCoordinates(results[2])
			src					<< output("[coordinates[1]],[coordinates[2]]","startingXY")

			//	By default, mg_TurfsToDoors will accept the location of the
			//	lower-left corner of the maze.  It will then return a list
			//	of the turfs associated with the door bits the generator
			//	decided for that location.  Honestly, it's probably not very
			//	useful when you're not using a turf per cell.  We just happen
			//	to be doing so in this demo so I'm using the doors as icon states.
			var
				list/turfs	= MG.mg_GetTurfsToDoors(1,1,1)
				turf/T
			for(T in turfs)	T.icon_state	= "[turfs[T]]"






/*


Below this is just demo-specific junk. =)


*/



//	I'm defining debug so you can use the profile tool.
#define DEBUG
//	I'm adjusting the view.
client
	view	= "70x70"
	perspective	= EDGE_PERSPECTIVE
//	I'm centering the view...  I could have used client.eye.
mob
	Login()
		src.loc	= locate(world.maxx/2,world.maxy/2,1)
		..()
//	I created a turf icon using Lummox JR's IconCutter.
turf
	icon	= 'path-joined.dmi'
